// This class is based on the FishDisplay class, version 1 August 2002
// by Alyce Brady

// AP(r) Computer Science Marine Biology Simulation:
// The LittleFishDisplay class is copyright(c) 2002 College Entrance
// Examination Board (www.collegeboard.com).
//
// This class is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation.
//
// This class is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

package model.fish.display;

/**
 * Display a small fish.
 *
 * @author Mathias Ricken
 */
public class LittleFishDisplay extends ParamFishDisplay {
    private static final double BODY_WIDTH = .2;
    private static final double BODY_LENGTH = .5;
    private static final double TAIL_WIDTH = .15;
    private static final double TAIL_LENGTH = .4;
    private static final double EYE_SIZE = .03;

    /**
     * Constructs an object that knows how to display teeny little fish.
     */
    private LittleFishDisplay() {
        super(BODY_WIDTH, BODY_LENGTH, TAIL_WIDTH, TAIL_LENGTH, EYE_SIZE);
    }

    /**
     * Singleton instance.
     */
    public static final LittleFishDisplay Singleton = new LittleFishDisplay();
}

