package sysModel.env;

import javax.swing.*;

/**
 * Abstract environment factory. Functions as a dynamic panel to input parameters and as a factory for the environment.
 *
 * @author Mathias Ricken
 */
public abstract class AEnvFactory extends JPanel {
    /**
     * Create an environment as specified by the parameters.
     *
     * @return global environment
     */
    public abstract AGlobalEnv create();

    /**
     * Return string representation.
     *
     * @return string representation
     */
    public abstract String toString();
}
